edu.msu.cme.rdp.classifier.train.validation

## Class HierarchyTree

- java.lang.Object
- - edu.msu.cme.rdp.classifier.train.validation.HierarchyTree

    public class HierarchyTree
    extends java.lang.Object

### Constructor Summary

Constructors
Constructor and Description
`HierarchyTree(java.lang.String n, HierarchyTree p, Taxonomy tax)` Creates new HierarchyTree given the name and its parent

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `changeParentSeqCount(int i)`
`void` `createWordOccurrenceFromSubclasses()` creates the word occurrence array from its children if the word occurrence for this node does not exist
`java.util.Collection` `getLeaves()` Gets the array of Sequenceleaves if any
`int` `getMissCount()`
`java.lang.String` `getName()` Gets the name of the treenode
`void` `getNodeList(java.lang.String level, java.util.List nodeList)` get all the lowest level nodes in given hierarchy level starting from the given root
`void` `getNodeMap(java.lang.String level, java.util.HashMap<java.lang.String,HierarchyTree> nodeMap)` get all the lowest level nodes in given hierarchy level starting from the given root
`int` `getNumberofUniqueWords()`
`int` `getNumOfLeaves()` Counts the number of sequence leaves below this tree
`int` `getNumTotalTestedseq()`
`HierarchyTree` `getParent()` Gets the parent treenode
`int` `getSizeofChildren()` Gets the size of the children
`int` `getSizeofLeaves()` Gets the size of sequence leaves directly belong to this tree, not including the hidden leaves
`int` `getSizeofSubclasses()` Gets the size of the subclasses
`HierarchyTree` `getSubclassbyName(java.lang.String n)` Gets the subclass with the given name
`java.util.Collection<HierarchyTree>` `getSubclasses()` Gets the array of the subclasses if any
`Taxonomy` `getTaxonomy()`
`int` `getTotalSeqs()`
`int` `getWordOccurrence(int wordIndex)` Gets the word occurrence for the given word index
`int` `getWordOccurrenceSize()`
`void` `hideSeq(edu.msu.cme.rdp.readseq.utils.orientation.GoodWordIterator iterator)` This method hides a sequence by removing the words of that sequence from the total wordOccurrence
`void` `incMissCount()`
`void` `incNumTotalTestedseq()`
`void` `increTotalSeqs()`
`void` `initWordOccurrence(LineageSequence pSeq, float[] wordPriorArr, boolean initWordOccurrence)` This method initiate the word occurrence from the sequences for the lowest level of the hierarchy tree
`boolean` `isSingleton()`
`boolean` `isWordOccurDone()`
`void` `unhideSeq(edu.msu.cme.rdp.readseq.utils.orientation.GoodWordIterator iterator)` This method initiate the word occurrence from the sequences for the lowest level of the hierarchy tree

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### HierarchyTree

    public HierarchyTree(java.lang.String n,
                         HierarchyTree p,
                         Taxonomy tax)

Creates new HierarchyTree given the name and its parent

### Method Detail

#### getName

    public java.lang.String getName()

Gets the name of the treenode

#### getParent

    public HierarchyTree getParent()

Gets the parent treenode

#### getSubclasses

    public java.util.Collection<HierarchyTree> getSubclasses()

Gets the array of the subclasses if any

#### getLeaves

    public java.util.Collection getLeaves()

Gets the array of Sequenceleaves if any

#### getSubclassbyName

    public HierarchyTree getSubclassbyName(java.lang.String n)

Gets the subclass with the given name

#### getSizeofChildren

    public int getSizeofChildren()

Gets the size of the children

#### getSizeofSubclasses

    public int getSizeofSubclasses()

Gets the size of the subclasses

#### getSizeofLeaves

    public int getSizeofLeaves()

Gets the size of sequence leaves directly belong to this tree, not including the hidden leaves

#### initWordOccurrence

    public void initWordOccurrence(LineageSequence pSeq,
                                   float[] wordPriorArr,
                                   boolean initWordOccurrence)
                            throws java.io.IOException

This method initiate the word occurrence from the sequences for the lowest level of the hierarchy tree

Throws:
  `java.io.IOException`

#### unhideSeq

    public void unhideSeq(edu.msu.cme.rdp.readseq.utils.orientation.GoodWordIterator iterator)
                   throws java.io.IOException

This method initiate the word occurrence from the sequences for the lowest level of the hierarchy tree

Throws:
  `java.io.IOException`

#### hideSeq

    public void hideSeq(edu.msu.cme.rdp.readseq.utils.orientation.GoodWordIterator iterator)
                 throws java.io.IOException

This method hides a sequence by removing the words of that sequence from the total wordOccurrence

Throws:
  `java.io.IOException`

#### changeParentSeqCount

    public void changeParentSeqCount(int i)

#### isWordOccurDone

    public boolean isWordOccurDone()

#### getWordOccurrenceSize

    public int getWordOccurrenceSize()

#### getNumberofUniqueWords

    public int getNumberofUniqueWords()

#### createWordOccurrenceFromSubclasses

    public void createWordOccurrenceFromSubclasses()

creates the word occurrence array from its children if the word occurrence for this node does not exist

#### getWordOccurrence

    public int getWordOccurrence(int wordIndex)

Gets the word occurrence for the given word index

#### getNumOfLeaves

    public int getNumOfLeaves()

Counts the number of sequence leaves below this tree

#### increTotalSeqs

    public void increTotalSeqs()

#### getTotalSeqs

    public int getTotalSeqs()

#### getMissCount

    public int getMissCount()

#### getNumTotalTestedseq

    public int getNumTotalTestedseq()

#### incNumTotalTestedseq

    public void incNumTotalTestedseq()

#### incMissCount

    public void incMissCount()

#### getTaxonomy

    public Taxonomy getTaxonomy()

#### isSingleton

    public boolean isSingleton()

#### getNodeList

    public void getNodeList(java.lang.String level,
                            java.util.List nodeList)

get all the lowest level nodes in given hierarchy level starting from the given root

#### getNodeMap

    public void getNodeMap(java.lang.String level,
                           java.util.HashMap<java.lang.String,HierarchyTree> nodeMap)

get all the lowest level nodes in given hierarchy level starting from the given root